﻿/******************************************
 *   IoTアプリケーション
 * 　気圧、温度、湿度をIFTTT経由で
 * 　Spread Sheetに送信
 *****************************************/
// グローバル変数定義
char DATA1[15], DATA2[13], DATA3[11], b;
float Pres, Temp, Humi;
/*******セットアップ関数　　****************/
void setup()
{
  delay(3000);
  pinMode(10, OUTPUT);
  digitalWrite(10, LOW);
  pinMode(8, OUTPUT);
  digitalWrite(8, HIGH);  
  Serial.begin(115200);
  delay(100);
}
/*********　メインループ関数　*********************/
void loop() // run over and over
{

  Pres = 1234.5;
  Temp = 34.5;
  Humi = 55.0; 

  Transfer();
  delay(1000000);
}
/****************************
*  受信しながら文字列を探す関数
****************************/
bool FindString(String target, uint32_t timeout)
{
    String data;
    char a, flag;
    unsigned long start = millis();

    flag = 0;
    while (millis() - start < timeout) {
        while(Serial.available() > 0) {
          a = Serial.read();
          if(a == '\0') continue;
            data += a;
        }
        if (data.indexOf(target) != -1) {
            flag = 1;
            break;
        }   
    }
    if(flag == 1)
      return true;
    else
      return false;
}

/***************************************
 * IFTT　送信関数
 * 　Pres、Temp、Humiの3値を送信
 * 　トリガ＝Add_Log
 **************************************/
void Transfer(void){ 
  char s[7],t[7],u[7];
  
  digitalWrite(8, LOW);                       // ESP リセット
  delay(100);
  digitalWrite(8, HIGH);
  delay(2000);       
  digitalWrite(10, HIGH);                     // 目印オン
  dtostrf(Pres, 5, 1, s);                     // 数値の文字変換
  dtostrf(Temp, 3, 1, t);
  dtostrf(Humi, 2, 0, u);
  sprintf(DATA1, "?value1=%s", s);            // 送信データ作成
  sprintf(DATA2, "&value2=%s", t);
  sprintf(DATA3, "&value3=%s", u);
  //ESP 送信開始
  Serial.print("AT+CWMODE=1\r\n");            // クライアントモード
  // アクセスポイントと接続
  if(FindString("OK",500)==false){Serial.println("NG\r\n");}
  Serial.print("AT+CWJAP=\"SSID\",\"Password\"\r\n");
  if(FindString("OK",6500)==false){Serial.println("NG\r\n");}
  // IFTTTサーバとTCP接続
  Serial.print("AT+CIPSTART=\"TCP\",\"maker.ifttt.com\",80\r\n");
  if(FindString("OK",500)==false){Serial.println("NG\r\n");}
  // パススルーモードにセット
  Serial.print("AT+CIPMODE=1\r\n");
  if(FindString("OK",1500)==false){Serial.println("NG\r\n");}
  // GETメッセージ送信
  Serial.print("AT+CIPSEND\r\n");         // 送信開始コマンド
  if(FindString("OK",1500)==false){Serial.println("NG\r\n");}
  Serial.print("GET /trigger/Add_Log/with/key/Keycode");
  Serial.print(DATA1);
  Serial.print(DATA2);
  Serial.print(DATA3);
  Serial.print(" HTTP/1.1\r\nHost: maker.ifttt.com\r\n\r\n");
//    // IFTTTサーバ応答確認用処理（デバッグ用） 
//    do{
//           if(Serial.available() > 0) {
//              b = Serial.read(); 
//            Serial.write(b);
//        }
//    } while(b != '\0');  
  delay(1000);                  // IFTTTサーバ処理待ち
  // パススルーモード解除
  Serial.print("+++");
  delay(1000);                  // ESP切替待ち
  // サーバ接続解除、AP接続切断
  Serial.print("AT+CIPCLOSE\r\n");
  if(FindString("OK",500)==false){Serial.println("NG\r\n");}
  Serial.print("AT+CWQAP\r\n");
  if(FindString("OK",500)==false){Serial.println("NG\r\n");} 
  digitalWrite(10, LOW);          // 目印オフ
} 
